###################################################################
#
# uninstallComponent - sucht in der Windows-Registry nach alten
# ProTeXt-Komponenten um diese zu lschen.
#
# Vers.: 1.0   ThF, 7/06
#
###################################################################

##### Packages #####

package require registry 1.0

##### Adjustable Globals #####

set MAINKEY "HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall";

##### Graphics... #####

wm title . uninstallComponent;

frame .protwin
frame .cmds
pack .protwin -side top -expand true -fill both
pack .cmds -side bottom -fill both -before .protwin


listbox .protwin.keylist -relief sunken -width 50 -height 5 \
    -selectmode extended -yscrollcommand ".protwin.scrolly set"

scrollbar .protwin.scrolly -command ".protwin.keylist yview" \
        -orient vertical -width 12

button .cmds.uninstall -text "Uninstall!" \
    -command {_startUninstall [.protwin.keylist curselection]}

button .cmds.end -text "Exit" \
    -command {exit}

pack .protwin.keylist -side left  -expand true -fill both
pack .protwin.scrolly -side right  -fill y -before .protwin.keylist
pack .cmds.end -side right -anchor se -pady 3 -padx 5
pack .cmds.uninstall -side right -anchor se -pady 3

##### Procedures... #####

proc _insertKeys {mainkey keypattern} {

global keycmds;

.protwin.keylist delete 0 end;
set keycmds "";

catch {set keylist [registry keys $mainkey $keypattern]}

if { [llength $keylist] != 0 } {

    .cmds.uninstall configure -state normal

    foreach i $keylist {

        lappend keycmds [registry get $mainkey\\$i "UninstallString"]
        .protwin.keylist insert end [registry get $mainkey\\$i "DisplayName"];

    }

    .protwin.keylist selection set 0;

} else {

    .cmds.uninstall configure -state disabled
    .protwin.keylist insert end "No related Software was found on your system...";

}

}; # end _insertKeys


proc _startUninstall {selindices} {

global keycmds MAINKEY SELPATTERN;

if { [llength $selindices] > 0 } {

    wm withdraw .

    foreach i $selindices {

        regsub -all "\\\\" [lindex $keycmds $i] "/" cmdline
        catch {eval exec $cmdline}

    }

    _insertKeys $MAINKEY $SELPATTERN
    wm deiconify .

}

}; # end _startUninstall

##### The Main Program... #####

set SELPATTERN "";
set keycmds "";

if {$argc == 1} {

    set SELPATTERN [lindex $argv 0];
    _insertKeys $MAINKEY $SELPATTERN;

} else {

    .cmds.uninstall configure -state disabled
    .protwin.keylist insert end "Invalid Number of Arguments!";

}

### Ende von uninstallComponent.tcl
